unit MainUnit;

{$mode objfpc}{$H+}

{*******************************************************************************
*          Demo Project for accessing Lazarus LCL Objects in a DLL             *
*                                                                              *
*          Latest changes:  2012-01-04   by Breakoutbox                        *
********************************************************************************
*  == LICENSE ==                                                               *
*  (C) 2009 Covac Software. You may copy, store, modify and sell this software *
*      as long as you keep copyright comments in the source code.              *
********************************************************************************
* Hints:                                                                       *
*   -  Do not activate compiler option "Methodenaufrufe prüfen (-CR)"          *
*      This leads to an Exception when assigning "Parent" in the DLL           *
*******************************************************************************}

interface

uses
  Classes, Forms, LResources, StdCtrls, ExtCtrls, SysUtils, FileUtil, Graphics,
  Dialogs, rwincontrol, MyLibraryInterface;



type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    ButtonClose: TButton;
    Panel1: TPanel;
    procedure Button1Click(Sender: TObject);
    procedure ButtonCloseClick(Sender: TObject);
  private
    { private declarations }
    Btn : TButton;
    Lbl : TLabel;
  public
    { public declarations }
  end; 


var
  Form1: TForm1; 


implementation

{ TForm1 }

procedure TForm1.ButtonCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TForm1.Button1Click(Sender: TObject);
var aParent : TRHandle;
begin
  // do not overwrite already initialized Objects !
  if FNcreateButton = NIL
    then
      begin
        aParent:= TRHandle( Panel1);  // typecast this !

        { create a Label from our DLL : }
        Lbl:= DLLcreateTLabel( aParent);

        { create a Button from our DLL : }
        Btn:= DLLcreateTButton( aParent);

        // for debug:  delay next actions to show the progress :
        Application.ProcessMessages;
        sleep( 700);

        { Look - You can change properties from outside the DLL : }
        TRY
          Btn.Caption:= 'Hello again';
          Btn.Left:= 30;
        EXCEPT {protect this code:  in case the DLL is missing
                we have a Btn pointer no NIL - there is no Button !}
               ShowMessage( 'Oh - looks like the DLL is missing ...' +#13
                            +'please first compile the DLL project !');
             end;

        beep; //You can hear - creating the Objects happens only once !
      end

    else
      begin

      end;
end;


initialization
  {$I MainUnit.lrs}

end.

